/* FILE: uniformscalarfield.cc     -*-Mode: c++-*-
 *
 * Uniform scalar field object, derived from Oxs_ScalarField
 * class.
 *
 */

#include "oc.h"
#include "nb.h"

#include "uniformscalarfield.h"

// Oxs_Ext registration support
OXS_EXT_REGISTER(Oxs_UniformScalarField);

/* End includes */


// Constructor
Oxs_UniformScalarField::Oxs_UniformScalarField(
  const char* name,     // Child instance id
  Oxs_Director* newdtr, // App director
  const char* argstr)   // MIF input block parameters
  : Oxs_ScalarField(name,newdtr,argstr)
{
  // Process arguments.
  value = GetRealInitValue("value");
  VerifyAllInitArgsUsed();
}

BOOL Oxs_UniformScalarField::Init()
{ return 1; }

REAL8m
Oxs_UniformScalarField::Value(const ThreeVector& /* pt */) const
{
  return value;
}

void
Oxs_UniformScalarField::FillMeshValue
(const Oxs_Mesh* mesh,
 Oxs_MeshValue<REAL8m>& array) const
{
  array.AdjustSize(mesh);
  UINT4m i,size=mesh->Size();
  for(i=0;i<size;i++) array[i]=value;
}
