/* FILE: filevectorfield.h      -*-Mode: c++-*-
 *
 * File vector field object, derived from Oxs_VectorField class.
 *
 */

#ifndef _OXS_FILEVECTORFIELD
#define _OXS_FILEVECTORFIELD

#include "oc.h"

#include "vectorfield.h"

/* End includes */

class Oxs_FileVectorField:public Oxs_VectorField {
private:
  Vf_Mesh* file_mesh;
  BOOL set_norm;
  REAL8m norm;
  REAL8m multiplier;
  ThreeVector scale,offset;
  REAL8m valuescale;
public:
  virtual const char* ClassName() const; // ClassName() is
  /// automatically generated by the OXS_EXT_REGISTER macro.
  virtual BOOL Init();
  Oxs_FileVectorField
  (const char* name,     // Child instance id
   Oxs_Director* newdtr, // App director
   const char* argstr);  // MIF input block parameters

  virtual ~Oxs_FileVectorField();

  virtual void Value(const ThreeVector& pt,ThreeVector& value) const;

  virtual void FillMeshValue(const Oxs_Mesh* mesh,
			     Oxs_MeshValue<ThreeVector>& array) const;
};


#endif // _OXS_FILEVECTORFIELD
