/* FILE: randomvectorfield.h      -*-Mode: c++-*-
 *
 * Random vector field object, derived from Oxs_VectorField class.
 *
 */

#ifndef _OXS_RANDOMVECTORFIELD
#define _OXS_RANDOMVECTORFIELD

#include "oc.h"

#include "vectorfield.h"

/* End includes */

class Oxs_RandomVectorField:public Oxs_VectorField {
private:
  REAL8m min_norm;
  REAL8m max_norm;
public:
  virtual const char* ClassName() const; // ClassName() is
  /// automatically generated by the OXS_EXT_REGISTER macro.
  virtual BOOL Init();
  Oxs_RandomVectorField
  (const char* name,     // Child instance id
   Oxs_Director* newdtr, // App director
   const char* argstr);  // MIF input block parameters

  virtual ~Oxs_RandomVectorField() {}

  virtual void Value(const ThreeVector& pt,ThreeVector& value) const;

  virtual void FillMeshValue(const Oxs_Mesh* mesh,
			     Oxs_MeshValue<ThreeVector>& array) const;
  virtual void
  FillMeshValueOrthogonal(const Oxs_Mesh* mesh,
			  const Oxs_MeshValue<ThreeVector>& orth_array,
			  Oxs_MeshValue<ThreeVector>& array) const;

};


#endif // _OXS_RANDOMVECTORFIELD

