/* FILE: scriptvectorfield.h      -*-Mode: c++-*-
 *
 * Tcl script vector field object, derived from Oxs_VectorField
 * class.
 *
 */

#ifndef _OXS_SCRIPTVECTORFIELD
#define _OXS_SCRIPTVECTORFIELD

#include <string>
#include <vector>

#include "oc.h"

#include "tclcommand.h"
#include "vectorfield.h"

/* End includes */

class Oxs_ScriptVectorField:public Oxs_VectorField {
private:
  BOOL set_norm;
  REAL8m norm;
  Oxs_ThreeVector basept;
  Oxs_ThreeVector scale;
  vector<Oxs_TclCommandLineOption> command_options;
  Oxs_TclCommand cmd;
public:
  virtual const char* ClassName() const; // ClassName() is
  /// automatically generated by the OXS_EXT_REGISTER macro.
  virtual BOOL Init();
  Oxs_ScriptVectorField
  (const char* name,     // Child instance id
   Oxs_Director* newdtr, // App director
   const char* argstr);  // MIF input block parameters

  virtual ~Oxs_ScriptVectorField();

  virtual void Value(const ThreeVector& pt,ThreeVector& value) const;

  virtual void FillMeshValue(const Oxs_Mesh* mesh,
			     Oxs_MeshValue<ThreeVector>& array) const;

};


#endif // _OXS_SCRIPTVECTORFIELD
